<?php
  include("conn.php");
  //Recupero parametros
  $vDataPeriodos     = $_POST['xDataPeriodos'];
  $vUnidades         = $_POST['xUnidades'];
  $vConceptos        = $_POST['xConceptos'];
  $vRubros           = $_POST['xRubros'];
  $vComprobantes     = $_POST['xComprobantes'];
  $vModuloMesas      = $_POST['xModuloMesas'];
  $vModuloMostrador  = $_POST['xModuloMostrador'];
  $vModuloDelivery   = $_POST['xModuloDelivery'];
  $vTurno            = $_POST['xTurno'];

  $sql = "SELECT PUESTO FROM " . $_SESSION["BaseMadre"] . "glPuestos WHERE DESCRI = 'TABLERO_WEB'";
  $RsPuesto = $DBSegu->Execute($sql);
  if (!$RsPuesto) {
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.01';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die();  
  }

  if ($RsPuesto->RecordCount() > 0) { 
    $sql = "SELECT PARAM FROM " . $_SESSION["BaseMadre"] . "glConfig WHERE PUESTO = " . $RsPuesto->fields['PUESTO'] . " AND CLAVE = 'COD_BARRA_VE'";
    $RsPuesto = $DBSegu->Execute($sql);
    if (!$RsPuesto) {
      $jsondata['success'] = false;
      $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.02';
      header('Content-type: application/json; charset=utf-8');
      echo json_encode($jsondata);
      die();  
    }

    if ($RsPuesto->RecordCount() == 0) {
      $muestraCodigo = 0; //rubro-codigo
    }
    else {
      if ($RsPuesto->fields['PARAM'] == 1) {
        $muestraCodigo = 1; //cod-barra
      }
      else {
        $muestraCodigo = 0; //rubro-codigo
      }
    }
  }
  else {
    $muestraCodigo = 0; //rubro-codigo
  }

//Armo el filtro de periodos;
  $cantidadPeriodos = 0;
  $sqlPeriodos = "";
  if ($vDataPeriodos != '') {
    $xDataPeriodos = json_decode($vDataPeriodos);
    $sqlPeriodos = " AND (";
    foreach ($xDataPeriodos as $value) {
      $cantidadPeriodos ++;
      if ($sqlPeriodos <> " AND (") {
        $sqlPeriodos .= " OR ";
      }
      $sqlPeriodos .= "(X.FECHA BETWEEN '" . $value->desde . "' AND '" . $value->hasta . "')";
    }
    $sqlPeriodos .= ")";
  }
  //Armo el filtro de empresas
  //el filtro de titulares se hace luego en el while de cada empresa
  $sqlEmpresas = '';
  if ($vUnidades != '') {
    $xUnidades = explode(',' , $vUnidades);
    $sqlEmpresas = " AND (";
    foreach ($xUnidades as $value) {
      $aux = explode('-', $value);
      
      if ($sqlEmpresas <> " AND (") {
        $sqlEmpresas .= " OR ";
      }
      $sqlEmpresas .= "(E.BASE = " . $aux[0] . ")";
    }
    $sqlEmpresas .= ")";
  }

  //Armo el filtro por módulo
  $sqlModulo = "";
  if ($vModuloMesas == 1) {
    $sqlModulo = "and (X.modulo = 'M' "; 
  }
  if ($vModuloDelivery == 1) {
    if ($sqlModulo == "") {
      $sqlModulo = "and (X.modulo = 'D' ";
    }
    else {
      $sqlModulo .= " or X.modulo = 'D' ";
    }  
  }
  if ($vModuloMostrador == 1) {
    if ($sqlModulo == "") {
      $sqlModulo = "and (X.modulo = 'B' ";
    }
    else {
      $sqlModulo .= " or X.modulo = 'B' ";
    }
  }
  if ($sqlModulo != "") {
    $sqlModulo .= ")"; 
  }

  //Armo filtro por turno
  $sqlTurno = "";
  if ($vTurno != '-1') { 
    $sqlTurno = "    INNER JOIN Reemplazo.dbo.caCierre C 
                     ON C.CIERRE = X.CIERRE 
                        AND C.PARCIAL = " . $_POST['xTurno'];
  }
  
  //Armo el filtro de conceptos y rubros; uso solo sqlProductos para ambos
  //ninguno
  if (($vConceptos == '') && ($vRubros == '')) {
    $sqlProductos = '';
  }

  //solo conceptos
  if (($vConceptos != '') && ($vRubros == '')) {
    $sqlProductos = '';
    $xConceptos = explode(',' , $vConceptos);
    $sqlProductos = " AND (";
    foreach ($xConceptos as $value) {
      if ($sqlProductos <> " AND (") {
        $sqlProductos .= " OR ";
      }
      $sqlProductos .= "(I.CONCEPTO = " . $value . ")";
    }
    $sqlProductos .= ")";
  }  

  //solo rubros
  if (($vConceptos == '') && ($vRubros != '')) {
    $sqlProductos = '';
    $xRubros = explode(',' , $vRubros);
    $sqlProductos = " AND (";
    foreach ($xRubros as $value) {
      if ($sqlProductos <> " AND (") {
        $sqlProductos .= " OR ";
      }
      $sqlProductos .= "(R.RUBRO = " . $value . ")";
    }
    $sqlProductos .= ")";
  }  

  //ambos
  if (($vConceptos != '') && ($vRubros != '')) {
    $sqlProductos = '';
    $xRubros = explode(',' , $vRubros);
    $xConceptos = explode(',' , $vConceptos);
    $sqlProductos = " AND (";
    foreach ($xRubros as $value) {
      if ($sqlProductos <> " AND (") {
        $sqlProductos .= " OR ";
      }
      $sqlProductos .= "(R.RUBRO = " . $value . ")";
    }
    foreach ($xConceptos as $value) {
      if ($sqlProductos <> " AND (") {
        $sqlProductos .= " OR ";
      }
      $sqlProductos .= "(I.CONCEPTO = " . $value . ")";
    }
    $sqlProductos .= ")";
  }  

  //Armo el filtro de comprobantes
  $sqlComprobantes = '';
  if ($vComprobantes != '') {
    $xComprobantes = explode(',' , $vComprobantes);
    $sqlComprobantes = " AND (";
    foreach ($xComprobantes as $value) {
    //$value->desde;
      if ($sqlComprobantes <> " AND (") {
        $sqlComprobantes .= " OR ";
      }
      $sqlComprobantes .= "(X.TIPO_MOV = " . $value . ")";
    }
    $sqlComprobantes .= ")";
  }

  function getTitulares($lista, $base) {
    $resu = '';

    if ($lista != '') {
      $xUnidades = explode(',' , $lista);
      $xxx = '';
      foreach ($xUnidades as $value) {
        $aux = explode('-', $value);
        if ($aux[0] == $base) {
          if ($xxx <> "") {
            $xxx .= ", ";
          }
        $xxx .= " " . $aux[1];
        }
      }
      $resu = " AND TITULAR IN (" . $xxx . ")";
    }

    return $resu;
  }
  $resu = '';

  //armo el script para crear la tabla temporal; la cantidad de columnas va a depender del la cantidad de periodos;
  $sqlTemporal = "create table #TablaTemporal (CONCEPTO INT, RUBRO INT, DESC_INSUMO varchar(250), DESC_RUBRO VARCHAR(250), MONTO1 MONEY default 0, CANTIDAD1 MONEY default 0, BARRA varchar(250)";
  for ($i = 2; $i <= $cantidadPeriodos; $i++) {
    $sqlTemporal .= ", MONTO".$i." MONEY default 0, CANTIDAD".$i." MONEY default 0";
  }
  $sqlTemporal .= ")";

  $RsTemporal = sqlsrv_query( $conn, $sqlTemporal);    
  if (! $RsTemporal ) {    
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.00';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die( print_r( sqlsrv_errors(), true));    
  }    
/*  $RsTemporal = $DBSegu->Execute($sqlTemporal);
  if (!$RsTemporal) {
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.00';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die();  
  }*/

  $sqlTemporal = "create NONCLUSTERED INDEX idx_TablaTemporal ON #TablaTemporal (CONCEPTO)";
  $RsTemporal = sqlsrv_query( $conn, $sqlTemporal);    
  if (! $RsTemporal ) {    
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.00';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die( print_r( sqlsrv_errors(), true));    
  }    
/*  $RsTemporal = $DBSegu->Execute($sqlTemporal);
  if (!$RsTemporal) {
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.00';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die();  
  }*/

  $misDatos = array();
  $ordenPeriodo = 0;
  foreach ($xDataPeriodos as $value) {
    $ordenPeriodo ++;
    $sqlBases = "SELECT DISTINCT E.BASE, E.DESCRI, E.NOMBRE_BASE 
                 FROM (SELECT XB.BASE, XB.DESCRI, XB.NOMBRE_BASE 
                       FROM BASES xB 
                            INNER JOIN USUARIOSBASES XUB 
                                INNER JOIN USUARIOS XU 
                                ON XUB.ID_USUARIO = XU.ID_USUARIO 
                                AND XU.USUARIO = 'PIXO_WEB' 
                            ON XB.BASE = XUB.BASE) E 
                      INNER JOIN USUARIOSBASES UB 
                          INNER JOIN USUARIOS U 
                          ON UB.ID_USUARIO = U.ID_USUARIO 
                      ON E.BASE = UB.BASE 
                 WHERE 1=1 ".$sqlEmpresas."
                 ORDER BY E.DESCRI";
    $RsEmpresas = $DBSegu->Execute($sqlBases);
    if (!$RsEmpresas) {
      $jsondata['success'] = false;
      $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.02';
      header('Content-type: application/json; charset=utf-8');
      echo json_encode($jsondata);
      die();  
    }

    $subConsulta = '';
    while (!$RsEmpresas->EOF) {
      $sqlTitulares = getTitulares($vUnidades, $RsEmpresas->fields['BASE']); 

      if ($subConsulta != '') {
        $subConsulta .= ' UNION ALL ';
      };

      $subConsulta .= "Select " . $RsEmpresas->fields['BASE'] . " as base, IV.comprob, IV.concepto, IV.cantidad, IV.precio, " .
                              $RsEmpresas->fields["NOMBRE_BASE"] . ".dbo.veImpoRel(IV.comprob,IV.item) as iva, X.fecha, 
                              T.credito, X.titular, X.tipo_mov 
                       From " . $RsEmpresas->fields["NOMBRE_BASE"] . ".dbo.veventas X 
                            inner join " . $RsEmpresas->fields["NOMBRE_BASE"] . ".dbo.veImputa IV 
                            on X.comprob = IV.comprob 
                            inner join " . $RsEmpresas->fields["NOMBRE_BASE"] . ".dbo.vetipomov T 
                            on T.tipo_mov = X.tipo_mov " .
                            str_replace('Reemplazo',$RsEmpresas->fields["NOMBRE_BASE"],$sqlTurno) . "
                       Where X.fecha between '" . $value->desde . "' AND '" . $value->hasta . "' " . 
                             $sqlTitulares .
                             $sqlComprobantes .
                             $sqlModulo .
                    " and isnull(IV.gravamen,0) = 0 ";


      $RsEmpresas->MoveNext();
    }

    //ERA CON RIGHT OUTER
    $sqlConsulta = "SELECT R.codigo as RUBRO, I.CONCEPTO, I.CODIGO, I.COD_BARRA, R.descri as DESC_RUBRO, I.descri as DESC_INSUMO, 
                          isnull(sum(cantidad * " . $_SESSION["BaseMadre"] . "valorcredito( V.credito)), 0) as CANTIDAD,
                          isnull(Round(sum((((V.precio * V.cantidad) + V.iva) * " . $_SESSION["BaseMadre"] . "valorcredito( V.credito))), 2), 0) as MONTO 
                    FROM (" . $subConsulta . ")  V 
                         INNER JOIN " . $_SESSION["BaseMadre"] . "glConceptos I 
                             INNER JOIN " . $_SESSION["BaseMadre"] . "glRubros R 
                             ON I.rubro = R.rubro " . $sqlProductos . "
                         ON V.concepto = I.concepto 
                    GROUP BY R.codigo, I.concepto, I.codigo, R.descri, I.descri, I.COD_BARRA 
                    ORDER BY R.codigo, I.codigo ";
//echo $sqlConsulta;
    $RsConsulta = $DBSegu->Execute($sqlConsulta);
    if (!$RsConsulta) {
      $jsondata['success'] = false;
      $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.03';
      header('Content-type: application/json; charset=utf-8');
      echo json_encode($jsondata);
      die();  
    }
   
    while (!$RsConsulta->EOF) {
      //echo $RsConsulta->fields['CONCEPTO'].'  ----  ';
      if ($ordenPeriodo == 1) {
        $sqlTemporal = "insert into #TablaTemporal (CONCEPTO, DESC_INSUMO, RUBRO, DESC_RUBRO, CANTIDAD1, MONTO1, BARRA) 
                          values (".$RsConsulta->fields['CONCEPTO'].", '".utf8_encode($RsConsulta->fields['DESC_INSUMO'])."', ".
                          $RsConsulta->fields['RUBRO'].", '".utf8_encode($RsConsulta->fields['DESC_RUBRO'])."', ".
                          $RsConsulta->fields['CANTIDAD'].", ".$RsConsulta->fields['MONTO'].", '" . $RsConsulta->fields['COD_BARRA']. "')";
        $RsTemporal = sqlsrv_query( $conn, $sqlTemporal);    
        if (! $RsTemporal ) {    
          $jsondata['success'] = false;
          $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.02';
          header('Content-type: application/json; charset=utf-8');
          echo json_encode($jsondata);
          die( print_r( sqlsrv_errors(), true));    
        }    
        // $RsTemporal = $DBSegu->Execute($sqlTemporal);
      }
      else {
        $sqlTemporal = "update #TablaTemporal set MONTO".$ordenPeriodo."=".$RsConsulta->fields['MONTO'].", CANTIDAD".$ordenPeriodo."=".$RsConsulta->fields['CANTIDAD']." where CONCEPTO=".$RsConsulta->fields['CONCEPTO'] . " IF @@ROWCOUNT = 0 BEGIN  insert into #TablaTemporal (CONCEPTO, DESC_INSUMO, RUBRO, DESC_RUBRO, CANTIDAD".$ordenPeriodo.", MONTO".$ordenPeriodo.", BARRA) 
                          values (".$RsConsulta->fields['CONCEPTO'].", '".utf8_encode($RsConsulta->fields['DESC_INSUMO'])."', ".
                          $RsConsulta->fields['RUBRO'].", '".utf8_encode($RsConsulta->fields['DESC_RUBRO'])."', ".
                          $RsConsulta->fields['CANTIDAD'].", ".$RsConsulta->fields['MONTO'].", '" . $RsConsulta->fields['COD_BARRA']. "') END";
        $RsTemporal = sqlsrv_query( $conn, $sqlTemporal);    
        if (! $RsTemporal ) {    
          $jsondata['success'] = false;
          $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.03';
          header('Content-type: application/json; charset=utf-8');
          echo json_encode($jsondata);
          die( print_r( sqlsrv_errors(), true));    
        }    
        //$RsTemporal = $DBSegu->Execute($sqlTemporal);
      }
      $RsConsulta->MoveNext();
    }
  } 

  //Obtengo los totales (para poder sacar porcentaje)
  $sqlTotal = "select SUM(CANTIDAD1) AS CANTIDAD1, SUM(MONTO1) AS MONTO1 ";
  for ($i = 2; $i <= $cantidadPeriodos; $i++) {
    $sqlTotal .= ", SUM(CANTIDAD".$i.") AS CANTIDAD".$i.", SUM(MONTO".$i.") AS MONTO".$i." ";
  }
  $sqlTotal .= "FROM #TablaTemporal  
                  WHERE CANTIDAD1 <> 0 ";
  for ($i = 2; $i <= $cantidadPeriodos; $i++) {
    $sqlTotal .= " OR CANTIDAD".$i." <> 0 ";
  }
  $RsTotales = sqlsrv_query( $conn, $sqlTotal);    
  if (! $RsTotales ) {    
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.04';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die( print_r( sqlsrv_errors(), true));    
  }    
  $rowTotales = sqlsrv_fetch_array( $RsTotales, SQLSRV_FETCH_ASSOC);
  /*$RsTotales = $DBSegu->Execute($sqlTotal);
  if (!$RsTotales) {
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.04';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die();  
  }*/

  //Obtengo del detalle a mostrar
  $sqlTemporal = "select CONCEPTO, RUBRO, DESC_INSUMO, DESC_RUBRO, CANTIDAD1, MONTO1 ";
  for ($i = 2; $i <= $cantidadPeriodos; $i++) {
    $sqlTemporal .= ", CANTIDAD".$i.", MONTO".$i." ";
  }
  $sqlTemporal .= "FROM #TablaTemporal  
                  WHERE CANTIDAD1 <> 0 ";
  for ($i = 2; $i <= $cantidadPeriodos; $i++) {
    $sqlTemporal .= " OR CANTIDAD".$i." <> 0 ";
  }
  $sqlTemporal .= "order by DESC_RUBRO, DESC_INSUMO";
  $RsTemporal = sqlsrv_query( $conn, $sqlTemporal);    
  if (! $RsTemporal ) {    
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.05';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die( print_r( sqlsrv_errors(), true));    
  }    
/*  $RsTemporal = $DBSegu->Execute($sqlTemporal);
  if (!$RsTemporal) {
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.05';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die();  
  }*/
  //ACA DEBO METER CORTE DE CONTROL POR RUBRO y en el título debo poner correctamente el de cada periodo
  $resu = ' <div class="row">
              <table id="tablaResultado" class="display table table-striped table-bordered sticky-header" style="width:100%">
                <thead style="background-color: #db5916; color: aliceblue;">
                  <tr class="falsetable">
                    <th class="falsetable"></th>
                    <th class="falsetable"></th>';

  for ($i = 1; $i <= $cantidadPeriodos; $i++) {
    if ($i > 1) {
      $resu .= '     <th class="falsetable"></th>
                     <th class="falsetable"></th>
                     <th class="falsetable"></th>
                     <th class="falsetable"></th>';
    }
    else {
      $resu .= '     <th class="falsetable"></th>
                     <th class="falsetable"></th>
                     <th class="falsetable"></th>';
    }
  }

  $resu .= '      </tr>
 
                  <tr>
                    <th class="thalign" rowspan="2">C&oacute;digo</th>
                    <th class="thalign tituloshead" rowspan="2">DESCRIPCI&Oacute;N</th>';
  for ($i = 1; $i <= $cantidadPeriodos; $i++) {
    $xxx = ($i > 1)?4:3;
    $resu .= '      <th colspan="'.$xxx.'" class="thalign fechastable" style="border-bottom: 0px;">'.$xDataPeriodos[$i-1]->desde.' - ' . $xDataPeriodos[$i-1]->hasta . '</th>';
  }
  $resu .='       </tr>
                  <tr>';
  for ($i = 1; $i <= $cantidadPeriodos; $i++) {
    if ($i > 1) {
      $resu .= '    <th class="thalign tituloshead">Evoluci&oacute;n</th>
                    <th style="width: 10%;" class="thalign tituloshead">Cantidad</th>
                    <th class="thalign tituloshead">Importe</th>
                    <th class="thalign tituloshead">%</th>';
    }
    else {
      $resu .= '    <th style="width: 10%;" class="thalign tituloshead">Cantidad</th>
                    <th class="thalign tituloshead">Importe</th>
                    <th class="thalign tituloshead">%</th>';
    }
  }
  $resu .='       </tr>
                </thead>
                <tbody>';
  $rubroAnt = -1;

  $acumuladorCantidad   = array();
  $acumuladorMonto      = array();
  $acumuladorPorcentaje = array();
  for ($x = 1; $x <= $cantidadPeriodos; $x++) {
    $acumuladorCantidad[$x]   = 0;
    $acumuladorMonto[$x]      = 0;
    $acumuladorPorcentaje[$x] = 0;
  }
  $auxTotal = '';
  //ojo, debo llevar contadores totales y de rubro por cada periodo  SQLSRV_FETCH_ASSOC
  //while (!$RsTemporal->EOF) {
  while( $row = sqlsrv_fetch_array( $RsTemporal, SQLSRV_FETCH_ASSOC)) {  
    if ($rubroAnt != $row['RUBRO']) {
      if ($rubroAnt != -1) {
        $resu .= '      <tr class="subtotales">';
        $resu .= '        <td colspan="2">TOTAL ' . $auxTotal . '</td><td style="display: none"></td>';
        for ($i = 1; $i <= $cantidadPeriodos; $i++) {
          if ($i > 1) {
            if ($row['CANTIDAD'.($i-1)] != 0) {
              if ((float)$acumuladorCantidad[$i-1] != 0) {
                $xDesvio = ((float)$acumuladorCantidad[$i] - (float)$acumuladorCantidad[$i-1]) / (float)$acumuladorCantidad[$i-1] * 100;
                $xDesvio = number_format((float)$xDesvio, 2) . '%';
              }
              else {$xDesvio = '---';}
            }
            else {
              $xDesvio = '---';
            }
            $resu .= '         <td class="numerico">'.$xDesvio.'</td>';
          }
          $resu .= '         <td class="numerico">' . number_format($acumuladorCantidad[$i], 2) . '</td>';
          $resu .= '         <td class="numerico">$' . number_format($acumuladorMonto[$i], 2) . '</td>';
          $resu .= '         <td class="numerico">' . number_format($acumuladorPorcentaje[$i], 2) . '%</td>';
        }
        $resu .= '      </tr>';  
      }
      
      $filas = 5 + (($cantidadPeriodos-1)*4);
      $resu .= '        <tr class="titulosfilas">';
      $resu .= '          <td style="border: 0;" colspan="2">' . $row['DESC_RUBRO'] . '</td><td style="display: none">';
      for ($i = 1; $i <= $cantidadPeriodos; $i++) {
        if ($i > 1) {
          $resu .= '         <td style="border: 0;"></td>';
        }
        $resu .= '         <td style="border: 0;"></td>';
        $resu .= '         <td style="border: 0;"></td>';
        $resu .= '         <td style="border: 0;"></td>';
      }
      $resu .= '      </tr>';  
      $rubroAnt = $row['RUBRO'];
      $auxTotal = $row['DESC_RUBRO'];
      for ($z = 1; $z <= $cantidadPeriodos; $z++) {
        $acumuladorCantidad[$z]   = 0;
        $acumuladorMonto[$z]      = 0;
        $acumuladorPorcentaje[$z] = 0;
      }
    }
    for ($i = 1; $i <= $cantidadPeriodos; $i++) {
      $acumuladorCantidad[$i] = (float)$acumuladorCantidad[$i] + (float)$row['CANTIDAD'.$i];
      $acumuladorMonto[$i] = (float)$acumuladorMonto[$i] + (float)$row['MONTO'.$i];
      if ((float)$rowTotales['CANTIDAD'.$i] != 0) {
        $porcentaje = ((float)$rowTotales['CANTIDAD'.$i] == 0)?0:(float)$row['CANTIDAD'.$i] * 100 / (float)$rowTotales['CANTIDAD'.$i];
      }
      else {
        $porcentaje = 0;
      }
      $acumuladorPorcentaje[$i] = (float)$acumuladorPorcentaje[$i] + $porcentaje;
    }
   
    $auxMostrar = ($muestraCodigo == 1)?'['.$row['BARRA'].']':'['.$row['RUBRO'] . ' - ' . $row['CONCEPTO'].']';

    $resu .= '      <tr>';
    $resu .= '        <td class="numerales">'.$auxMostrar.'</td><td>' . utf8_encode($row['DESC_INSUMO']) . '</td>';
    for ($i = 1; $i <= $cantidadPeriodos; $i++) {
      if ($i > 1) {
        if ($row['CANTIDAD'.($i-1)] != 0) {
          $xDesvio = ((float)$row['CANTIDAD'.$i] - (float)$row['CANTIDAD'.($i-1)]) / (float)$row['CANTIDAD'.($i-1)] * 100;
          $xDesvio = number_format((float)$xDesvio, 2) . '%';
        }
        else {
          $xDesvio = '---';
        }
        $resu .= '         <td class="numerico">'.$xDesvio.'</td>';
      }
      $resu .= '         <td class="numerico">' . number_format($row['CANTIDAD'.$i], 2) . '</td>';
      $resu .= '         <td class="numerico">$' . number_format($row['MONTO'.$i], 2) . '</td>';
      if ((float)$rowTotales['CANTIDAD'.$i] != 0) {
        $porcentaje = ((float)$rowTotales['CANTIDAD'.$i] == 0)?0:(float)$row['CANTIDAD'.$i] * 100 / (float)$rowTotales['CANTIDAD'.$i];
      }
      else { 
        $porcentaje = 0;
      }
      $resu .= '         <td class="numerico">' . number_format($porcentaje, 2) . '%</td>';
    }
    $resu .= '      </tr>';  

    //$RsTemporal->MoveNext();
  }
  //pinto el total del último rubro
  $resu .= '      <tr class="subtotales">';
  $resu .= '        <td colspan="2">TOTAL ' . $auxTotal . '</td><td style="display: none"></td>';
  for ($i = 1; $i <= $cantidadPeriodos; $i++) {
    if ($i > 1) {
      $resu .= '         <td class="numerico"></td>';
    }
    $resu .= '         <td class="numerico">' . number_format($acumuladorCantidad[$i], 2) . '</td>';
    $resu .= '         <td class="numerico">$' . number_format($acumuladorMonto[$i], 2) . '</td>';
    $resu .= '         <td class="numerico">' . number_format($acumuladorPorcentaje[$i], 2) . '%</td>';
  }
  $resu .= '      </tr>
                </tbody>';

  $resu .= '    <!--<tfoot>-->
                  <tr style="background-color: #3e3e3e; color: aliceblue;">
                    <th class="thalign" colspan="2">Total General</th>';

  for ($i = 1; $i <= $cantidadPeriodos; $i++) {
    if ($i > 1) {
      $resu .= '    <th class="thalign"></th>';
    }
    $resu .= '      <th class="thalign">' . number_format($rowTotales['CANTIDAD'.$i], 2) . '</th>';
    $resu .= '      <th class="thalign">$' . number_format($rowTotales['MONTO'.$i], 2) . '</th>';
    $resu .= '      <th class="thalign"></th>';
  }

  $resu .= '      </tr>
                <!--</tfoot>-->
              </div>
            </table>';


  $resu .= '</div>';

  $jsondata = array();
  $jsondata['success'] = true;
  $jsondata['message'] = $resu;
  
  header('Content-type: application/json; charset=utf-8');
  echo json_encode($jsondata);
  die();  
?>